/**
 * By handling the same structure as the original library,
 * We can add the specific overrides for web while keeping the modularity of the library.
 */
export type { StateSetter, HookExtensions, ObservableFragment, MetadataSetter, StateChanges, StoreTools, ActionCollectionResult, GlobalStoreCallbacks, UseHookConfig, UnsubscribeCallback, SubscribeCallbackConfig, SubscribeCallback, StateGetter, BaseMetadata, MetadataGetter, CustomGlobalHookBuilderParams, SelectorCallback, SubscriberParameters, SubscriptionCallback, StateHook, ActionCollectionConfig, } from './types';
export { shallowCompare } from './shallowCompare';
export { uniqueId } from './uniqueId';
export { throwWrongKeyOnActionCollectionConfig } from './throwWrongKeyOnActionCollectionConfig';
export { isRecord } from './isRecord';
export { uniqueSymbol, type UniqueSymbol } from './uniqueSymbol';
export { useStableState, type UseStableState } from './useStableState';
export { type ContextProviderAPI, type ContextProvider, type ContextHook, type CreateContext, type createContext, } from './createContext';
export { type LocalStorageConfig } from './types';
export { GlobalStore } from './GlobalStore';
export { GlobalStoreAbstract } from './GlobalStoreAbstract';
export { CreateGlobalState, createGlobalState } from './createGlobalState';
export { createCustomGlobalState, CustomCreateGlobalState } from './createCustomGlobalState';
export { getLocalStorageItem } from './getLocalStorageItem';
export { setLocalStorageItem } from './setLocalStorageItem';
export { generateStackHash } from './generateStackHash';
